myTestlsPrimary & Co. : fix design
03 Feb 2020 12:58 - Anna Maria Bigatti
Priority: Normal Due date:

Assignee: Anna Maria Bigatti % Done: 100%
Category: Safety Estimated time: 6.66 hours
Target version: CoCoALib-0.99710 Spent time: 6.60 hours
Description

| spent a few hours fixing a bug in

bool SparsePolyRingBase::IdealImpl::myTestIsPrimary_0dim() const

Now | can claim it was just due to my bad design of returning a bool:

this way | have actually fooled myself (as author+maintainer) in believing this just returns a bool. Instead, the main effect of this
function is setting the primary flag.

This is quite common in C++ (changing+returning) but it is more dangerous than useful.

Change this into void, test, and fix all its companions.

Related issues:

Related to CoCoALib - Design #924: FlagManager for bool/bool3 flags New 19 Sep 2016
Related to CoCoALib - Feature #899: IsMaximal, IsPrimary for IDEAL (in cocoa... Closed 27 Jun 2016
Related to CoCoALib - Bug #1411: IsPrimary sometimes wrong Closed 03 Feb 2020
Related to CoCoALib - Bug #1411: IsPrimary sometimes wrong Closed 03 Feb 2020
Related to CoCoA-5 - Support #1387: John's visit Feb 2020 Closed 07 Jan 2020
History

#1 - 03 Feb 2020 12:59 - Anna Maria Bigatti
- Related to Design #924: FlagManager for bool/bool3 flags added

#2 - 03 Feb 2020 12:59 - Anna Maria Bigatti
- Related to Feature #899: IsMaximal, IsPrimary for IDEAL (in cocoalib) added

#3 - 03 Feb 2020 13:20 - Anna Maria Bigatti

This was the error, found by Ashkan Nikseresht (nice feedback! thanks!)

/* */ K::=2Z/(2);

/* */ Use S::=K[a,b,x,vy];

/* *x/ al:=a"2+a+l;

/* */ bel:=b"2 +(a)*b +(1);

/* */ J:=ideal (al, bel, (x-a)"2, (y-b"2));

/* */ IsPrimary (J);

true

/* */ Iz:=Elim([a,b],J);

/* */ IZ;

ideal (x"4 +x72 +1, XN2*y +yh2 +1, yi3 +x72 +y"2 +1)
/* */ Use R::=K[x,vy];

/* */ phi:=PolyAlgebraHom(S,R, [0,0,x,v]);

/* */ Il:=ideal (apply (phi,gens(Iz)));

/* */ Il;

ideal (x"4 +x72 +1, x"2*y +y"2 +1, y"3 +x"2 +y"2 +1)
/* */ radi:=Radical (I1);

/* */ IsMaximal (radi);

true

/* */ IsPrimary (Il);
false

#4 - 03 Feb 2020 13:21 - Anna Maria Bigatti

| added the test to exbugs.cocoab

#5 - 03 Feb 2020 15:39 - John Abbott
- Status changed from New to In Progress

- % Done changed from 20 to 50

| fixed this as well. Anyway, we can merge when I'm in Italy (hopefully).

| agree that the use of myAssignPrimaryFlag efc. is risky because one can easily make a mistake...
How to find a safer design?

#6 - 03 Feb 2020 15:40 - Anna Maria Bigatti

- Related to Bug #1411: IsPrimary sometimes wrong added

#7 - 03 Feb 2020 15:40 - John Abbott
- Related to Bug #1411: IsPrimary sometimes wrong added

#8 - 04 Feb 2020 13:38 - John Abbott

- Description updated
The corrected code should be in 0.99700.
We should discuss the design when I'm in Genoa. Maybe we can finish this for 0.997007?

Changing return type to void is probably reasonable; but then we may want to change the name slightly.

#9 - 04 Feb 2020 13:38 - John Abbott
- Related to Support #1387: John's visit Feb 2020 added

#10 - 05 Feb 2020 13:35 - John Abbott

| like the suggestion to change the fn to void. Still we should discuss it when I'm there.
Also we should look to see if there are other similar fns whose design should be changed.

As a safety feature we could put CoCoA_ASSERT (!IsUncertain3(myPrimaryFlag)) after the call.
Even "better" we could implement as follows: main fn calls the one that does the work, then
makes the assertion. While this is safer (since you cannot forget to write the assertion

after every call), it seems to complicate the impl more than I'd like.

As a compromise, we could put assertions just before every return in the fn which actually does the work (and hope that we do not forget one).

#11 - 11 Feb 2020 18:25 - John Abbott
- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99700

#12 - 12 Feb 2020 08:48 - Anna Maria Bigatti
- Target version changed from CoCoALib-0.99700 to CoCoALib-0.99800
- % Done changed from 50 to 90

Fixed all functions myTest... so that they return void.
Now the compiler should help if something is not done properly (returned, instead of assigned).
Code looked a bit prettier before, but | found other similar mismatches while updating the code!

John Abbott wrote:

As a safety feature we could put CoCoA_ASSERT(!IsUncertain3(myPrimaryFlag)) after the call.

Even "better" we could implement as follows: main fn calls the one that does the work, then
makes the assertion.

| actually called CoCoA_ASSERT_ALWAYS (with comment // paranoia2020) in IsPrime, IsRadical, ...

#13 - 14 Feb 2020 10:58 - John Abbott

- Status changed from In Progress to Closed
- % Done changed from 90 to 100

- Estimated time set to 6.66 h

Appears to work now. Closing.

#14 - 30 Apr 2020 14:20 - Redmine Admin
- Target version changed from CoCoALib-0.99800 to CoCoALib-0.99710
